; Dekoder ASCII na string

; Autor: Remek

.386
.model flat,stdcall
option casemap:none

include C:\masm32\include\windows.inc

include C:\masm32\include\user32.inc
include C:\masm32\include\kernel32.inc

includelib C:\masm32\lib\user32.lib
includelib C:\masm32\lib\kernel32.lib

  includelib C:\masm32\lib\remeka.lib

   _byte_na_str PROTO

.data

klasa       	db "WinClass",0
tytul       	db "       Dekoder ASCII na string", 0
classbutton 	db "button",0
Button1Text 	db "Exit",0
Button2Text 	db "OK",0
classedit  	db "edit", 0
space		db "spacja", 0
linefee		db "Line Feed", 0
cariageret	db "Cariage Return", 0
Bufor1       	db 32 dup (0)
Bufor2      	db 32 dup (0)
Bufor3      	db 32 dup (0)

.data?

uchwyt      dd ?
hEdit1      dd ?
hEdit2      dd ?

.const

Button1ID   equ 3
Button2ID   equ 4
;ID_ICON_CAPTION    equ  101

.code

start:

    push 0
    call GetModuleHandleA
    mov uchwyt,eax
    
    call WinMain
    
    push 0
    call ExitProcess

WinMain proc

   
    LOCAL decstr2:DWORD
    LOCAL wc:WNDCLASSEX
    LOCAL msg:MSG
    LOCAL hwnd:HWND
    mov wc.cbSize,SIZEOF WNDCLASSEX
    mov wc.style,CS_HREDRAW or CS_VREDRAW   
    mov wc.lpfnWndProc,offset WndProc
    mov wc.cbClsExtra,0
    mov wc.cbWndExtra,0
    push uchwyt
    pop wc.hInstance
    mov wc.hbrBackground,COLOR_WINDOW
    mov wc.lpszMenuName,0
    mov wc.lpszClassName,offset klasa

    invoke LoadIconA,uchwyt, 101	;lub ID_ICON_CAPTION, mona na dwa sposoby 	
    mov wc.hIcon,eax
    mov wc.hIconSm,eax
    
    invoke LoadCursor, 0, IDC_ARROW

    mov wc.hCursor,eax

    push eax
    lea eax,dword ptr [wc]
    push eax
    call RegisterClassEx
    pop eax
    
    invoke CreateWindowEx, WS_OVERLAPPEDWINDOW or WS_EX_DLGMODALFRAME or WS_EX_WINDOWEDGE,\
           addr klasa, addr tytul, WS_TILEDWINDOW or WS_CAPTION,480, 300,\
           300, 90, 0, 0, uchwyt, 0	
    	mov hwnd,eax
    invoke ShowWindow, hwnd, SW_SHOWNORMAL
    invoke UpdateWindow, hwnd

messageloop:

    push 0
    push 0
    push 0
    lea ebx,dword ptr [msg]
    push ebx
    call GetMessage
    test eax,eax
    jz koniec_messageloop

    lea ecx,dword ptr [msg]
    push ecx
    call TranslateMessage

    lea edx,dword ptr [msg]
    push edx
    call DispatchMessage
    jmp messageloop

koniec_messageloop:

    mov eax,msg.wParam
    ret

WinMain endp

WndProc proc hWnd:HWND,uMsg:UINT,wParam:WPARAM,lParam:LPARAM
    
    cmp uMsg,WM_DESTROY
    jnz nie_destroy
    
    push 0
    call PostQuitMessage
   
nie_destroy:

    cmp uMsg,WM_CREATE
    jnz nie_create

   invoke CreateWindowEx,WS_EX_CLIENTEDGE,ADDR classedit,0, WS_CHILD or WS_VISIBLE or WS_BORDER or ES_RIGHT OR ES_AUTOHSCROLL or ES_UPPERCASE,\
          10,10,200,22, hWnd, 0, uchwyt, 0 	
    	mov hEdit1,eax
    	push hEdit1
    	call SetFocus
   
    invoke CreateWindowEx, WS_EX_CLIENTEDGE, addr classedit, 0, WS_CHILD or WS_VISIBLE or WS_BORDER or ES_RIGHT,\
	   10, 33, 200, 22, hWnd, 0, uchwyt, 0
       mov hEdit2, eax
        
    invoke CreateWindowEx, 0, addr classbutton, addr Button2Text, WS_CHILD or WS_VISIBLE or BS_DEFPUSHBUTTON,\
	   225, 10, 60, 22, hWnd, Button1ID, uchwyt, 0
 
    invoke CreateWindowEx, 0, addr classbutton, addr Button1Text, WS_CHILD or WS_VISIBLE or BS_DEFPUSHBUTTON,\
	   225, 33, 60, 22, hWnd, Button2ID, uchwyt, 0

nie_create:

	cmp uMsg,WM_COMMAND
    	jnz dalej
	mov eax,wParam
        cmp ax,Button1ID
        jnz Button2
        shr eax,16
        cmp ax,BN_CLICKED
        jnz Button2

	mov dword PTR [Bufor1], 00h
	mov dword PTR [Bufor1+4], 00h
       
        invoke GetWindowTextA,hEdit1,addr Bufor1,0FFh

	mov dword PTR [Bufor2], 00h
	mov dword PTR [Bufor2+4], 00h
	mov dword PTR [Bufor2+8], 00h
	mov dword PTR [Bufor2+12], 00h
	mov dword PTR [Bufor2+16], 00h
	mov dword PTR [Bufor2+20], 00h
      	
	push esi     			
	push edi
	push ebp
	push ebx     

	lea  esi, Bufor1     	
	lea  edi, Bufor2
	invoke _byte_na_str
	lea  edi, Bufor2
	cmp  byte ptr [edi], 20h
	jz   spacja
	cmp  byte ptr [edi], 0Ah
	jz   linefeed
	cmp  byte ptr [edi], 0Dh
	jz   cariage
	jnz  idzdal
spacja:
	invoke SetWindowTextA, hEdit2, addr space
	jmp  omin
linefeed:
	invoke SetWindowTextA, hEdit2, addr linefee
	jmp  omin
cariage:
	invoke SetWindowTextA, hEdit2, addr cariageret
	jmp  omin

idzdal:
        pop ebx
	pop ebp	    
        pop edi           		
	pop esi  	      		
        
        invoke SetWindowTextA, hEdit2, addr Bufor2
	push hEdit1
        call SetFocus
	jmp  Button2
omin:
	pop ebx
	pop ebp	    
        pop edi           		
	pop esi
    
Button2: 
    	
        cmp ax,Button2ID
        jnz dalej
        shr eax,16
        cmp ax,BN_CLICKED
        jnz dalej
        invoke PostQuitMessage, 0
	
dalej:
       invoke DefWindowProc, hWnd, uMsg, wParam, lParam 
     ret

WndProc endp


end start

