;Program napisany gwnie w celu sprawdzenia dziaania rozbudowanej ptli komunikatw
;skonstruowanej w oparciu o instrukcje warunkowe high-level syntax (skadnia 
;wysokiego poziomu), czyli pseudo-instrukcji .IF .ELSE.

; Autor: Remek

.386
.MODEL FLAT,STDCALL
OPTION CASEMAP:NONE

INCLUDE    C:\masm32\include\windows.inc
INCLUDE    C:\masm32\include\user32.inc
INCLUDE    C:\masm32\include\kernel32.inc
INCLUDELIB C:\masm32\lib\user32.lib
INCLUDELIB C:\masm32\lib\kernel32.lib

INCLUDELIB C:\masm32\lib\remeka.lib

   _czy_hex          PROTO
   _dec_hex          PROTO 
   _dword2bin        PROTO
   _hex_na_dec	     PROTO
   _odwrot           PROTO
   _strhex_na_dwordp PROTO
   _wyswietl         PROTO


DlgProc PROTO :DWORD, :DWORD, :DWORD, :DWORD

.data

DlgName     DB "MyDialog",0
AppName1    DB "    Komunikat",0
AppName2    DB "        About",0
AppName3    DB "  Version info",0
AppName4    DB "         Info!",0
TestString  DB "Pierwszy tekst", 0
TestString1 DB "Drugi tekst", 0
TestString2 DB "Autor: Remek", 0
TestString3 DB "Grudzie 2005", 0
TestString4 DB "Plik pomocy w przygotowaniu", 0
msgTytul    db "Info", 0   
Bufor       db 24 DUP(0)
Bufor1      db 24 DUP(0)
Bufor2      db 24 DUP(0)
Bufor3      db 24 DUP(0)
Bufor4      db 24 DUP(0)


.data?

hInstance   HINSTANCE ?
CommandLine LPSTR     ?

.CONST

IDC_EDIT1    EQU  3000
IDC_EDIT2    EQU  3010
IDC_BUTTON   EQU  3001
IDC_BUTTON1  EQU  3002

IDM_POPUP1   EQU 32001			
IDM_POPUP2   EQU 32002			
IDM_CLEAR    EQU 32003
IDM_CLEAR1   EQU 32004
IDM_EXIT     EQU 32005
IDM_OBLHEX   EQU 32006
IDM_OBLDEC   EQU 32007
IDM_EXIT1    EQU 32008
IDM_POMOC1   EQU 32009
IDM_POMOC2   EQU 32010
IDM_POMOC3   EQU 32011


.CODE

start:

    invoke GetModuleHandle, NULL
	mov hInstance, eax
    invoke DialogBoxParam, hInstance, addr DlgName, NULL, ADDR DlgProc, NULL

zamknij:
    invoke ExitProcess, eax

DlgProc PROC hWnd:HWND, uMsg:UINT, wParam:WPARAM, lParam:LPARAM

    		.IF uMsg==WM_INITDIALOG
           invoke GetDlgItem, hWnd, IDC_EDIT1
           invoke SetFocus, eax
	       .ENDIF

    		.IF uMsg==WM_CLOSE         
          invoke EndDialog, hWnd, NULL
    	      .ENDIF

    	        .IF uMsg==WM_COMMAND		
    		mov eax, wParam
     		mov dx, WORD PTR wParam + 2				
                .IF dx==BN_CLICKED
                .IF ax==IDC_BUTTON				;Wpisz w EDIT1
    invoke SetDlgItemText, hWnd, IDC_EDIT1, addr TestString 
	    				
                .elseif ax==IDC_BUTTON1				;Wpisz w EDIT2
    invoke SetDlgItemText, hWnd, IDC_EDIT2, addr TestString1
	      .endif	
            .endif
 		
	        .if uMsg==WM_COMMAND		
                .if lParam==0					;Menu Plik 
                .if ax==IDM_POPUP1				;Pierwszy komunikat
    invoke GetDlgItemText, hWnd, IDC_EDIT1, addr Bufor, 0FFh
    invoke MessageBox, NULL, addr Bufor, addr AppName1, MB_OK
	    
                .elseif ax==IDM_POPUP2				;Drugi komunikat
    invoke GetDlgItemText, hWnd, IDC_EDIT2, addr Bufor, 0FFh
    invoke MessageBox, NULL, addr Bufor, addr AppName1, MB_OK
			
                .elseif ax==IDM_CLEAR				;Wyczy EDIT1	
    invoke SetDlgItemText, hWnd, IDC_EDIT1, NULL
	          
    	        .elseif ax==IDM_CLEAR1				;Wyczy EDIT2
    invoke SetDlgItemText, hWnd, IDC_EDIT2, NULL

	        .elseif ax==IDM_EXIT				;Koniec
    invoke EndDialog, hWnd, NULL		
                	
								;Menu Edit 
                .elseif	ax==IDM_OBLHEX				;Oblicz hex
			   
    invoke GetDlgItemText, hWnd, IDC_EDIT1, addr Bufor, 0FFh	;Pobiera tekst z EDIT1
    	mov ecx, eax

	push edi
	push esi
	push ebp
	push ebx

	lea esi, Bufor
	call _dec_hex  
	cmp eax, 'b'
	jz jeszcz 
	lea esi, Bufor1
	mov dword ptr [Bufor1], edi
	lea edi, Bufor2
	call _wyswietl 

	pop ebx
	pop ebp
	pop esi
	pop edi 

    invoke SetDlgItemText, hWnd, IDC_EDIT2, addr Bufor2
  ret

jeszcz:

	pop ebx
	pop ebp
	pop esi
	pop edi	 
    	
    invoke SetDlgItemText, hWnd, IDC_EDIT1, 0
    invoke SetDlgItemText, hWnd, IDC_EDIT2, 0  
  ret

		.elseif ax==IDM_OBLDEC				;Oblicz dec
	   
     invoke GetDlgItemText, hWnd, IDC_EDIT1, addr Bufor, 0FFh	;Pobiera tekst z EDIT1
    	mov dword PTR [Bufor3], eax
	mov edx, offset Bufor

	push edi
	push esi
	push ebp
	push ebx
		
	lea  esi, Bufor
	call _czy_hex
	cmp  ecx, 'dec'
	jz   musze
	mov  eax, dword PTR [Bufor3]
	mov  esi, offset Bufor
	mov  edi, offset Bufor1
	call _odwrot 
	lea  esi, Bufor1
	lea  edi, Bufor2
	call _strhex_na_dwordp
	mov  eax, [edi]
	lea  esi, Bufor4
	call _hex_na_dec	
		
	pop ebx
	pop ebp
	pop esi
	pop edi 

    invoke SetDlgItemText, hWnd, IDC_EDIT2, addr Bufor4
 ret

musze:
    invoke SetDlgItemText, hWnd, IDC_EDIT1, 0
    invoke SetDlgItemText, hWnd, IDC_EDIT2, 0
 ret

                .elseif ax==IDM_EXIT1				;Zamknij
     invoke EndDialog, hWnd, NULL
								;Menu Pomoc  
                 .elseif ax==IDM_POMOC1				;Autor
    invoke MessageBox, NULL, addr TestString2, addr AppName2, MB_OK
                .elseif ax==IDM_POMOC2				;Wersja
    invoke MessageBox, NULL, addr TestString3, addr AppName3, MB_OK
                .elseif ax==IDM_POMOC3				;Pomoc
    invoke MessageBox, NULL, addr TestString4, addr AppName4, MB_OK

            .endif	 	
          .endif	
        .endif

    .ELSE
        mov eax, FALSE
      ret
  .endif					

        mov eax, TRUE
     ret
	
DlgProc ENDP


END start
