;Plik rdowy biblioteki "moja.dll"
;
; Autor: Remek
;
;W bibliotece zdefiniowane s nastpujce procedury: 
;
; 1 _byte_na_str      - Na wejciu: w esi adres BufIn, w ecx adres BufOut
; 2 _czy_bin          - Na wejciu: w esi adres inBufor, w eax hWnd, lub GhWnd dialogu
; 3 _czy_hex          - Na wejciu: w esi adres BufIn. 
; 4 _dec_hex	      - Na wejciu: w esi adres BufIn, w ecx ilo znakw do obrbki.
;                       Na wyjciu: w edi wynik		
; 5 _dword2binstr     - Na wejciu: w eax dword, w edi adres BufOut
; 6 _hex_na_dec       - Na wejciu: w eax dword do konwersji, w esi adres BufOut
; 7 _hex_na_deca      - Na wejciu: w eax dword do konwersji, w esi adres BufOut
;
; 8 _hex2str	      - Na wejciu: w eax dword, w edi adres BufOut
; 9 
;10 _kwadrat	      - Na wejciu: w eax dword. Na wyjciu: w eax wynik (dword)	
;11 _lstr	      - Na wejciu: w esi adres BufIn, w edi adres BufOut	
;12 _odwrot	      - Na wejciu: w esi adres BufIn, w edi adres BufOut
;13 _strbin_dword     - Na wejciu: w edx adres BufIn. Na wyjciu: w edi wynik  
;14 _str_na_byte      - Na wejciu: w esi adres BufIn, w edi adres BufOut 
;15 _strhex_na_dword  - Na wejciu: w esi adres InBuf. Na wyjciu: w edi wynik
;16 _strhex_na_dwordp - Na wejciu: w esi adres InBuf, w edi adres OutBuf
;17 _wyswietl         - Na wejciu: w esi adres BufIn, w edi adres BufOut
; 
; Opisy dziaania procedur znajduj si przy kadej z nich.

.586
.model flat,stdcall
option casemap:none

  include C:\masm32\include\windows.inc
  include C:\masm32\include\user32.inc
  include C:\masm32\include\kernel32.inc
  includelib C:\masm32\lib\user32.lib
  includelib C:\masm32\lib\kernel32.lib

   
.data

msgTytul	db "  Error!!!", 0
msgTekst	db "Wpisz 0-9", 0
msgTekst2	db "Wpisz 0-1", 0

.data?

GhWnd           dd ?
IDC_EDIT1       dd ?
IDC_EDIT2       dd ?
IDC_EDIT3       dd ?
IDC_EDIT4       dd ?
IDC_EDIT5       dd ?


.code

Dllmoja proc hInstance:HINSTANCE, reason:DWORD, reserved1:DWORD

	cmp        reason,DLL_PROCESS_ATTACH
         jz        Dll_ok
        cmp        reason,DLL_PROCESS_DETACH
         jz        Dll_ok
        cmp        reason,DLL_THREAD_ATTACH
         jz        Dll_ok
        cmp        reason,DLL_THREAD_DETACH
         jz        Dll_ok
        jmp        Dll_ok

Dll_ok:
        mov  eax, TRUE
      ret

Dllmoja Endp

;
;========== _byte_na_str PROC ===============================================================
;
; Procedura zamienia kod ASCII wpisany w Edit na odpowiadajcy mu znak
;
; Na wejciu: w esi adres BufIn, w edi adres BufOut 
;
; Autor: Remek

 _byte_na_str PROC

	xor  eax, eax

pobierz:
	
	mov  al, byte ptr [esi]
	cmp  al, 0
	jz   zako
	cmp  al, 'A'
	jae  litera

	sub  al, 30h
	jmp  dale

litera:
	sub  al, 37h
dale:
	rol  al, 4
	inc  esi
	add  byte ptr [edi], al
	mov  al, byte ptr [esi]
	cmp  al, 0
	jz   zako
	cmp  al, 'A'
	jae  literb
	sub  al, 30h
	jmp  dalek
literb:
	sub  al, 37h
dalek:
	add  byte ptr [edi], al
	inc  edi
	inc  esi
	jmp  pobierz
zako:
     ret

 _byte_na_str ENDP

;_____________ koniec _byte_na_str __________________________________________________________
;

;
;========= _czy_bin PROC ==================================================================== 
;

_czy_bin PROC ;IDC_EDIT1:DWORD, IDC_EDIT2:DWORD, IDC_EDIT3:DWORD, IDC_EDIT4:DWORD,IDC_EDIT5:DWORD 
	      ;Powyszy wiersz jest wpisany w celu sprawdzenia sposobu deklaracji funkcji. 
	      ;Na razie wyczamy, bo jest niepotrzebny	

	mov GhWnd, edx

	pop  edx
	pop  eax
	mov  IDC_EDIT1, eax
	pop  eax
	mov  IDC_EDIT2, eax
	pop  eax
	mov  IDC_EDIT3, eax
	pop  eax
	mov  IDC_EDIT4, eax
	pop  eax
	mov  IDC_EDIT5, eax
	push edx	       
	
tata:											
	cmp ecx, 00h		;Czy s jeszcze znaki w Edit1					
	jz aaaa	
	mov bl, [esi]	
	cmp bl, 32h		;instrukcje sprawdzajce czy wpisany znak mieci si w zakresie	
	jae messag		;0 - 1. Kiedy znak wychodzi z tego zakresu nastepuje skok do 
	inc esi			;messag i wywoanie komunikatu.
	dec ecx	
	jmp tata

messag:
	invoke MessageBox,GhWnd,addr msgTekst2,addr msgTytul,MB_OK  

; Jeli w miejsce hInstance wpiszemy 0, MessageBox wyskoczy, ale bdzie pod oknem gwnym.

	invoke SetDlgItemText, GhWnd, IDC_EDIT1, 0
	invoke SetDlgItemText, GhWnd, IDC_EDIT2, 0	;GhWnd - zmienna globalna przechowujca
							;uchwyt okna dialogowego
	invoke SetDlgItemText, GhWnd, IDC_EDIT3, 0
	invoke SetDlgItemText, GhWnd, IDC_EDIT4, 0
	invoke SetDlgItemText, GhWnd, IDC_EDIT5, 0
        invoke GetDlgItem, GhWnd, IDC_EDIT1
        invoke SetFocus, eax
		mov  eax, 'A' 
aaaa:
	
     ret	

_czy_bin ENDP

;___________ koniec _czy_bin ________________________________________________________________
;

;
;============ _czy_hex PROC =================================================================
; 
; Jeli do Edit zostanie wpisany znak z poza zakresu 0 - F wywietlony zostanie
; MessageBox i po naciniciu OK program zostanie zamknity.

; Autor: Remek

msgTekst1	db "Wpisywane znaki musz mieci si w zakresie 0-F", 0
msgTytul1	db "Info", 0

_czy_hex	PROC

	push 	eax
	push    esi
	
	mov	al, byte PTR [esi]    	
	cmp	al, 47h
	jae	messag
	inc	esi

	mov	al, byte PTR [esi]
	cmp	al, 47h
	jae	messag
	inc	esi

	mov	al, byte PTR [esi]
	cmp	al, 47h
	jae	messag
	inc	esi

	mov	al, byte PTR [esi]
	cmp	al, 47h
	jae	messag
	inc	esi

	mov	al, byte PTR [esi]	
	cmp	al, 47h
	jae	messag
	inc	esi

	mov	al, byte PTR [esi]	
	cmp	al, 47h
	jae	messag
	inc	esi

	mov	al, byte PTR [esi]	
	cmp	al, 47h
	jae	messag
	inc	esi

	mov	al, byte PTR [esi]	
	cmp	al, 47h
	jae	messag
	jb	dobr
		
messag:
	invoke MessageBox, 0, addr msgTekst1, addr msgTytul1, MB_OK 
        mov     ecx, 'dec'
dobr:
	pop     esi
	pop	eax

      ret

_czy_hex ENDP

;________________ koniec _czy_hex ___________________________________________________________
;

;
;============== _dec_hex PROC =============================================================== 
;
; Procedura pobiera z edita wpisan liczb z zakresu 0-9 (w ptli s instrukcje sprawdzajce 
; czy wpisany znak mieci si w zakresie), zmienia pobrany string na dword i jako liczb
; dziesitn konwertuje na szesnastkow. 
;
; Na wejciu: W esi adres BuffIn, w ecx ilo pobranych znakw.  
;
; Na wyjciu: wynik w edi
;
; Autor: Remek

_dec_hex PROC
	
	push esi
	xor ebx, ebx
	xor edi, edi
	mov al, 0Ah		  
tata:											
	cmp ecx, 00h		;Czy s jeszcze znaki					
	jz aaaa				
	mov bl, [esi]	
	cmp bl, 30h		;instrukcje sprawdzajce czy wpisany znak mieci si w zakresie	
	je dalej		;0 - 9. Kiedy znak wychodzi z tego zakresu nastepuje skok do 		
	jb messag		;messag i wywoanie komunikatu, a nastpnie wyjcie z programu.						
	cmp bl, 31h									
	je dalej									
	cmp bl, 32h									
	je dalej									
	cmp bl, 33h									
	jb dalej									
	cmp bl, 34h									
	je dalej									
	cmp bl, 35h									
	je dalej									
	cmp bl, 36h									
	je dalej									
	cmp bl, 37h									
	jb dalej									
	cmp bl, 38h									
	je dalej									
	cmp bl, 39h									
	je dalej									
	ja messag
											
dalej:											
	test bl, bl								
	jz aaaa										
	sub bl, 30h									
        imul edi, eax							
	add edi, ebx		; wynik jest w edi							
	inc esi									
	dec ecx							
	jmp tata		
messag:
	
	invoke MessageBox, 0, addr msgTekst, addr msgTytul, MB_OK or MB_ICONWARNING
	mov eax, 'b'
aaaa:
	pop esi
     ret
	
_dec_hex ENDP

;______________ koniec _dec_hex ____________________________________________________________
;

;
;============== _dword2binstr PROC =========================================================
;
; mov   eax, imm32
; mov   edi, offset buffer
; call  _hex2str
;
; konvertuje DWORDa podanego w EAX na jego reprezentacj binarn w ASCII (string)
;
; na wejciu: w eax dword, w edi
; imm32  - DWORD, ktry ma by konwertowany
; buffer - offset bufora gdzie zostanie zapisany przekonwertowany DWORD
;
; na wyjciu:
; string w ASCII


_dword2binstr proc near

		mov	dword ptr [edi], 0
                mov	dword ptr [edi+4], 0
                mov	dword ptr [edi+8], 0
                mov	dword ptr [edi+12], 0
                mov	dword ptr [edi+16], 0
                mov	dword ptr [edi+20], 0
                
		pushad				; zapamitaj wszystkie rejestry 32bitowe
		push	31			; 32bity
		pop	ecx			; do konwersji
		xchg	eax, edx
_dword2bin_loop:			
		bt	edx, ecx		; ustaw CF (carry flag) jeli jest bit
		setc	al			; 
		or	al, 30h			; 30h="0" - zamiana na ASCII
		stosb				; Store AL at address ES:EDI
		dec	ecx
		jns	_dword2bin_loop		; konwertuj wszystkie 32 bity
		
		popad				; przywr stan wszystkich rejestrw
		
      ret

_dword2binstr endp

;_____________ koniec _dword2binstr _________________________________________________________
;

;
;============= _hex_na_dec PROC =============================================================
;
;Procedura zamienia wpisan liczb szesnastkow na posta dziesitn 
;
;D:\Nowy Asm\Xhemjl\Hex na dec.htm  
;
;Autor: Borzych. Adaptacja do Asm32: Remek
;
;Na wejciu:
;
;mov  eax, dword
;mov  esi, offset bufOut (Bufor1). T lini naley umieci tu przed wywoaniem _hex_na_dec
;
;
;Na wyjciu:
;
;Liczba dziesitna w bufOut pod adresem w esi
;
;

_hex_na_dec	PROC

	
;---=== blok konwersji na system dziesitny ===---

        mov     cl, 10                  ;ptla bdzie powtarzana 10 razy
	movzx	ecx, cl
        mov     edi, 10                 ;dzielnik do edi
        mov     bl, 12                  ;bx wskazuje na ostatni element
	movzx	ebx, bl

zamiana:                                ;ptla zamiany kolejnych cyfr
        xor     edx, edx                 
        div     edi            		;dzielenie edx:eax, wynik w eax, reszta w edx
        add     dl, '0'                 ;zamiana na ASCII
        mov     byte PTR [esi+ebx], dl  ;na koniec tablicy dodajemy kolejn cyfr
        dec     bx                      ;wskazuje na starsz cyfr

        cmp     bx, 9                   ;dzieli na trjki
        je      z_przerwa
        cmp     bx, 5                   ;dzieli na trjki
        je      z_przerwa
        cmp     bx, 1                   ;dzieli na trjki
        je      z_przerwa

        loop    zamiana
        jmp     usuwanie_zer            ;jak skoczy, idzie do usuwania zer

z_przerwa:
        dec     bx                      ;dodaje przerw
        loop    zamiana                 ;i wraca do ptli

usuwanie_zer:
        mov     cx, 12                  ;ptla usuwania zer
        mov     bx, 0                   ;wskazuje na pocztek tablicy

zera:                                   
        cmp     byte PTR [esi+ebx], '0' ;usunicie pocztkowych zer
        jne     przerwy                 ;jeeli pocztkowe rne od zera
        inc     bx                      ;idzie dalej
        loop    zera			;powtarzanie dla kolejnych cyfr

przerwy:
        mov     byte PTR [esi+9], ' '     ;robi z '0' przerwy
        mov     byte PTR [esi+5], ' '     ;robi z '0' przerwy
        mov     byte PTR [esi+1], ' '     ;robi z '0' przerwy
		
    ret                     

_hex_na_dec	ENDP
  
;______________ koniec _hex_na_dec __________________________________________________________
;

;
;=============== _hex_na_deca PROC ==========================================================
;
; Procedura zamienia wpisan liczb hex na posta dziesitn. Suy do wywietlania reszty 
; z dzielenia. Wywietla tylko 3 znaki. 
;
; Autor: Borzych. Adaptowana do Asm32.
;
; Na wejciu:
;
; w eax dword do konwersji 
; w esi adres BufOut
; 

 _hex_na_deca	PROC

        mov     cl, 3                   ;ptla bdzie powtarzana 3 razy
        movzx   ecx, cl
        mov     edi, 10                 ;dzielnik do edi
        mov     bl, 2
        movzx   ebx, bl                 ;bx wskazuje na ostatni element

zamiana:                                ;ptla zamiany kolejnych cyfr
        mov     edx, 0                  
        div     edi          		;dzielenie edx:eax, wynik w eax, reszta w edx
        add     dl, 30h                 ;zamiana na ASCII
        mov     byte ptr [esi+ebx], dl  ;na koniec tablicy dodajemy kolejn cyfr
        dec     bx                      ;wskazuje na starsz cyfr

        loop    zamiana
    ret                     

 _hex_na_deca	ENDP
  
;______________ koniec _hex_na_deca ________________________________________________________
;
;
;============= _hex2str PROC ===============================================================
;
; na wejciu:
; imm32  - w eax DWORD, ktry ma by konwertowany ()
; buffer - w edi adres bufora gdzie zostanie zapisany przekonwertowany DWORD
;
; na wyjciu:
; brak
;
; modyfikowane rejestry:
; eax, ecx
;
; bart/xt
;
_hex2str proc

	push	8			; liczba powtrze ptli
	pop	ecx			; do rejestru ecx
	
_hs_convert_loop:

	push	eax			
	and	eax,0000000Fh		; kolejne powki

	add	al,30h			; zamie na char
	cmp	al,'9'
	jbe	_hs_store_char
	add	al,7

_hs_store_char:

	mov	byte ptr[edi+ecx-1], al	; zapisz bajt do bufora wyjciowego
	pop	eax
	shr	eax,4
	dec	ecx
	jne	_hs_convert_loop

      ret

_hex2str endp

;_____________ koniec _hex2str ______________________________________________________________
;

;
;========== _kwadra PROC ====================================================================
;
; Procedura podnosi do kwadratu liczb dec z zakresu 0 - 65535	
; Jeli liczb pobieramy z kontrolki edit trzeba j przepuci przez procedur "dec_hex",  
; a wynik przez "hex_na_dec" i "wyswietl".
  
; Autor: Remek

_kwadra PROC

	mov ecx, edi
	mov eax, ecx
	mul ecx
	mov edi, eax

      ret

_kwadra ENDP

;_____________ koniec _kwadra ______________________________________________________________
;

;
;================= _kwadrat PROC ===========================================================
;
; Procedura podnosi do kwadratu liczb dec z zakresu 0 - 65535	
; Jeli liczb pobieramy z kontrolki edit trzeba j przepuci przez procedur "dec_hex", 
; a wynik przez "hex_na_dec"

_kwadrat PROC
	
	mov eax, edi
	mul edi
    ret

_kwadrat ENDP

;_______________ koniec _kwadrat ___________________________________________________________
;

;
;================= _lstr PROC ==============================================================
;
;Procedura zwraca w eax dugo stringa do ktrego podano offset
;
;Na wejciu: W esi adres BuffIn 		
;
;Na wyjciu: Liczba znakw stringu w eax
;

_lstr PROC
	
	xor eax, eax 			
	push esi
starta:
		
	cmp byte ptr [esi], 0 		;czy koniec znakw
	jz  zakoa 			;jak tak, to skok
	inc eax 			;zwiksz rejestr
	inc esi 			;zwiksz offset do tekstu
	jmp starta 			;licz dalej
					;w EAX liczba znakw
zakoa: 					
	pop  esi 
	
     ret

_lstr ENDP

;_____________ koniec _lstr ________________________________________________________________
;

;
;=============== _odwrot PROC ==============================================================
;
;Procedura odwracajca kolejno znakw w buforze. String jest pobierany z Edit funkcj 
;GetWindowTextA do Bufor. Funkcja zwraca w eax ilo pobranych znakw co jest wykorzystane w 
;procedurze.
;
;Na wejciu: Na wejciu: w esi adres BufIn, w edi adres BufOut
;

_odwrot proc

	push	esi	
	xor	edx, edx
	mov	dword PTR [edi], 0
	mov	dword PTR [edi+4], 0

powt:	
	mov	byte PTR dl, [esi+eax-1]    ;pobieramy string od koca
	dec	esi
	mov	byte PTR [edi], dl
	inc	edi
	cmp	dl, 0
	jnz	powt
	
	pop	esi

      ret

_odwrot endp

;_________________ koniec _odwrot __________________________________________________________
;

;
;============== _strbin_dword PROC ========================================================== 
;
;Procedura pobiera z edita wpisan liczb z zakresu 0-1 (w ptli s instrukcje sprawdzajce  
;czy wpisany znak mieci si w zakresie), zmienia pobrany string na dword i jako liczb 
;binarn konwertuje na szesnastkow. 
;Przed wywoaniem procedury naley w rdle przepisa z eax do ecx ilo znakw pobranych 
;z edit.
;
; mov ecx, eax     	;t instrukcj umieszczamy tu za wywoaniem GetWindowTextA.
; wynik jest w edi

; Autor: Remek

_strbin_dword PROC
	
	xor ebx, ebx
	xor edi, edi

	mov eax, 02h		  
tata:											
	cmp ecx, 00h		;Czy s jeszcze znaki					
	jz aaaa				
	mov bl, [edx]	
	cmp bl, 30h		;instrukcje sprawdzajce czy wpisany znak mieci si w 	
	je dalej		;zakresie 0 - 1. Kiedy znak wychodzi z tego zakresu nastepuje 
	jb messag		;skok do messag i wywoanie komunikatu, a nastpnie wyjcie						
	cmp bl, 31h		;z programu.
	jb messag								
	je dalej									
											
dalej:											
	test bl, bl								
	jz aaaa										
	sub bl, 30h									
        imul edi, eax						
	add edi, ebx		; wynik jest w edi								
	inc edx									
	dec ecx			
	jmp tata	
	
messag:
	invoke MessageBox, 0, addr msgTekst, addr msgTytul, MB_OK 
       
aaaa:
	ret
	
_strbin_dword ENDP

;______________ koniec _strbin_dword ________________________________________________________
;

;
;========= _str_na_byte PROC ================================================================
;
; Procedura zamieniajca zawarto rejestru w hex na znaki w ASCII.
; Wynik jest w buforze pod adresem w ecx. Dziaa w zakresie liczb hex
; Na wejciu: w esi adres BufIn, w edi adres BufOut


 _str_na_byte PROC	

jesz:
	mov   al, byte PTR [esi]	;pobieranie znakw z bufora
	cmp   al, 00h
	jz    zako

	movzx eax, al
	ror   eax, 4
	cmp   al, 0Ah
	jae   litera	
	jmp   cyfra

litera:
	add   al, 37h
	jmp   dale
cyfra:	
	add  al, 30h
dale:	
	mov  [edi], al

	mov   al, byte PTR [esi]	;pobieranie znakw z bufora
	cmp   al, 00h
	jz    zako
	movzx eax, al
	and   al, 0Fh
	cmp   al, 0Ah
	jae   literab	
	jmp   cyfrab

literab:	
	add   al, 37h
	jmp   dalea
cyfrab:
	add  al, 30h
dalea:	
	inc   edi
	mov   [edi], al
	inc   edi
	inc   esi
	jmp   jesz
zako:
	ret

 _str_na_byte ENDP

;____________ koniec _str_na_byte ___________________________________________________________
;

;
;================== _strhex_na_dword PROC ======================================================
;
;Procedura zamienia wpisany znak na liczb w hex. Oznacza to nastpujc operacj:
;W edit wpisujemy np. A, w buforze i w rejestrze pojawi si 41h. Jeli chcemy wykona jakie
;dziaania na A to musimy 41h przeksztaci w rejestrze lub buforze na A. 
;
;Na wejciu: W esi adres BuffIn 

; Autor: Remek

_strhex_na_dword PROC

	xor     eax, eax
	xor	edi, edi
	mov	esi, edx

	mov	al, byte PTR [esi]    	
	cmp	al, 0
	jz	_ret

	cmp	al, 41h
	jae	jare
	sub	al, 30h		
	jmp	kara
jare:
	sub	al, 37h
kara:
	add	edi, eax
	inc	esi

	mov	al, byte PTR [esi]
	cmp	al, 0
	jz	_ret
	movzx	eax, al
	
	cmp	al, 41h
	jae	jarf
	sub	al, 30h		
	jmp	karb
jarf:
	sub	al, 37h
karb:
	rol	eax, 4
	add	edi, eax
	inc	esi

	mov	al, byte PTR [esi]
	cmp	al, 0
	movzx	eax, al
	jz	_ret

	cmp	al, 41h
	jae	jarg
	sub	al, 30h		
	jmp	karc
jarg:
	sub	al, 37h
karc:
	rol	eax, 8
	add	edi, eax
	inc	esi

	mov	al, byte PTR [esi]
	cmp	al, 0
	movzx	eax, al
	jz	_ret

	cmp	al, 41h
	jae	jarh
	sub	al, 30h		
	jmp	kard
jarh:
	sub	al, 37h
kard:
	rol	eax, 0Ch
	add	edi, eax
	inc	esi

	mov	al, 	byte PTR [esi]	
	cmp	al, 0
	movzx	eax, al
	jz	_ret

	cmp	al, 41h
	jae	jari
	sub	al, 30h		
	jmp	kare
jari:

	sub	al, 37h
kare:
	rol	eax, 10h
	add	edi, eax
	inc	esi

mov	al, 	byte PTR [esi]	
	cmp	al, 0
	movzx	eax, al
	jz	_ret

	cmp	al, 41h
	jae	jarj
	sub	al, 30h		
	jmp	karf
jarj:

	sub	al, 37h
karf:
	rol	eax, 14h
	add	edi, eax
	inc	esi

	mov	al, 	byte PTR [esi]	
	cmp	al, 0
	movzx	eax, al
	jz	_ret

	cmp	al, 41h
	jae	jark
	sub	al, 30h		
	jmp	karg
jark:

	sub	al, 37h
karg:
	rol	eax, 18h
	add	edi, eax
	inc	esi

	mov	al, 	byte PTR [esi]	
	cmp	al, 0
	movzx	eax, al
	jz	_ret

	cmp	al, 41h
	jae	jarl
	sub	al, 30h		
	jmp	karh
jarl:

	sub	al, 37h
karh:
	rol	eax, 1Ch
	add	edi, eax	;wynik w edi   
	
_ret:
	
    ret

_strhex_na_dword ENDP

;________________ koniec _strhex_na_dword ____________________________________________________
;

;
;==================== _strhex_na_dwordp PROC  ================================================
;
;Wersja przystosowana do wsppracy z hex_na_dec Xhemjl adaptowan do asm32.
;Procedura zamienia wpisany znak na liczb w hex. Oznacza to nastpujc operacj:
;W edit wpisujemy np. A, w buforze i w rejestrze pojawi si 41h. Jeli chcemy wykona jakie
;dziaania na A to musimy 41h przeksztaci w rejestrze lub buforze na A. 
;
; Na wejciu: w esi adres InBuf, w edi adres OutBuf
;
; Uywane rejestry: ebx, edx

; Autor: Remek

_strhex_na_dwordp PROC

	push	esi
	push    edi

  	mov	dword ptr [edi], 0
	mov	dword ptr [edi+4], 0
	
napo:	
	mov	bl, byte PTR [esi]
	movzx   ebx, bl
	cmp	bl, 0
	jz	_ret

	cmp	bl, 41h
	jae	jare
	sub	bl, 30h		
	jmp	kara
jare:
	sub	bl, 37h
kara:
	xor	edx, edx
	add	edx, ebx
	inc	esi

	mov	bl, byte PTR [esi]
	movzx	ebx, bl
	cmp	bl, 0h
	jz	zako
	
	cmp	bl, 41h
	jae	jarf
	sub	bl, 30h		
	jmp	karb
jarf:
	sub	bl, 37h
karb:
	rol	ebx, 4
	add	edx, ebx
	inc	esi
zako:
	mov	byte PTR [edi], dl
	inc	edi
	jmp	napo
	
_ret:
	pop     edi
	pop	esi

      ret

_strhex_na_dwordp	ENDP

;__________________ koniec _strhex_na_dwordp PROC ___________________________________________
;

;
;================= _wyswietl PROC ===========================================================
;
; Procedura zamienia znaki z rejestru na ich kody ASCII i przepisuje je do Bufor1. Wersja z 
; zastosowaniem ptli. Nie ma ograniczenia do 8 bajtw (znakw). 

_wyswietl PROC
	
	push edi
	mov ecx, 11h	
	mov ebx, 0Fh	
prze:
	xor edx, edx
	mov dl, byte ptr [esi]
	dec cl
	jz  zako
	and edx, 0Fh
	cmp  dl, 0Ah
	jae hexy

	add dl, 30h
	mov byte ptr [edi+ebx], dl
	jmp dale
hexy:
	add dl, 37h
	mov byte ptr [edi+ebx], dl
dale:
	dec ebx
		
	xor edx, edx
	mov dl, byte ptr [esi]
	dec cl
	jz  zako
	ror edx, 04h
	cmp  dl, 0Ah
	jae hexya

	add dl, 30h
	mov byte ptr [edi+ebx], dl
	jmp dale1
hexya:
	add dl, 37h
	mov byte ptr [edi+ebx], dl
dale1:
	dec ebx
	inc esi
	jmp prze

zako:
	pop  edi
	
       ret

_wyswietl ENDP

;________________ koniec _wyswietl _________________________________________________________
;

End Dllmoja

