; Konwerter hex / dec  
; Procedura hex/dec z \Xhemjl\Hex na dec.htm  Autor: Borzych.
; Wersja z "rcznym" adowaniem biblioteki.

; Autor: Remek

.386
.model flat,stdcall
option casemap:none

include C:\masm32\include\windows.inc
include C:\masm32\include\user32.inc
include C:\masm32\include\kernel32.inc
include C:\masm32\include\gdi32.inc
includelib C:\masm32\lib\user32.lib
includelib C:\masm32\lib\kernel32.lib
includelib C:\masm32\lib\gdi32.lib

.data

klasa       	db "WinClass",0
tytul       	db "  hex/dec   max dword",0
classbutton 	db "button",0
Button1Text 	db "Exit",0
Button2Text 	db "OK",0
Edit3Text 	db "HEX:",0
Edit4Text 	db "DEC:",0
classedit  	db "edit",0
classedit1  	db "STATIC",0
msgTekst	db "Wpisywane znaki musz mieci si w zakresie 0-F", 0
msgTytul	db "Info", 0    
LibName		db "remeka.dll", 0
szFunction1     db "_odwrot", 0
szFunction3     db "_strhex_na_dwordp", 0
szFunction4     db "_hex_na_dec", 0  
msgTekst2 	db "Nie mona odnale remeka.dll", 0
msgTytul2	db "Error!", 0  
dziesietnie	db 24 dup(?)
Bufor       	db 24 dup(?)
Bufor1      	db 24 dup(?)
Bufor2      	db 24 dup(?)
Bufor3      	db 24 dup(?)

.data?

uchwyt      	dd ?
hEdit1      	dd ?
hEdit2      	dd ?
hEdit4      	dd ?
hLib            dd ?  ; uchwyt do otwartej biblioteki (DLL)
Function1Offset dd ?  ; adres funkcji importowanej z biblioteki
Function3Offset dd ?  ; adres funkcji importowanej z biblioteki
Function4Offset dd ?  ; adres funkcji importowanej z biblioteki

.const

Button1ID   equ 3
Button2ID   equ 4

.code

start:

    invoke GetModuleHandleA, 0
    mov uchwyt,eax
    
    call WinMain
zamknij:    
    push 0
    call ExitProcess

WinMain proc

    LOCAL wc:WNDCLASSEX
    LOCAL msg:MSG
    LOCAL hwnd:HWND
    mov wc.cbSize,SIZEOF WNDCLASSEX
    mov wc.style,CS_HREDRAW or CS_VREDRAW   ;poczyta o tym 
    mov wc.lpfnWndProc, offset WndProc
    mov wc.cbClsExtra,0
    mov wc.cbWndExtra,0
    push uchwyt
    pop wc.hInstance
    mov wc.hbrBackground, LTGRAY_BRUSH	;DKGRAY_BRUSH	;COLOR_WINDOW
    mov wc.lpszMenuName,0
    mov wc.lpszClassName, offset klasa
    invoke LoadIcon, 0, IDI_APPLICATION
    mov wc.hIcon,eax
    mov wc.hIconSm,eax
    invoke LoadCursor, 0, IDC_ARROW
    mov wc.hCursor, eax

    push eax
    lea eax,dword ptr [wc]
    push eax
    call RegisterClassEx
    pop eax

        
    invoke CreateWindowEx, WS_EX_CLIENTEDGE or WS_OVERLAPPEDWINDOW, addr klasa, addr tytul, WS_TILEDWINDOW, 530, 400,\
	     260, 90, 0, 0, uchwyt, 0	
    mov hwnd, eax
    
    invoke ShowWindow, hwnd, SW_SHOWNORMAL
    invoke UpdateWindow, hwnd

messageloop:

    	push 0
    	push 0
    	push 0
    	lea ebx,dword ptr [msg]
    	push ebx
    	call GetMessage             
    	test eax,eax
    	jz koniec_messageloop

    	lea ecx,dword ptr [msg]
    	push ecx
    	call TranslateMessage

    	lea edx,dword ptr [msg]
    	push edx
    	call DispatchMessage
    	jmp messageloop

koniec_messageloop:

    	mov eax,msg.wParam
      ret

WinMain endp

WndProc proc hWnd:HWND,uMsg:UINT,wParam:WPARAM,lParam:LPARAM
    
    cmp uMsg,WM_DESTROY
    jnz nie_destroy
    
    invoke PostQuitMessage, 0

nie_destroy:

    cmp uMsg,WM_CREATE
    jnz nie_create

    invoke CreateWindowEx, WS_EX_CLIENTEDGE, addr classedit, 0, WS_CHILD or WS_VISIBLE or WS_BORDER or ES_RIGHT or ES_UPPERCASE,\   ;BS_RIGHT or 
 	   75, 10, 90, 22, hWnd, 0, uchwyt, 0 	
    	mov hEdit1,eax
    	invoke SetFocus, hEdit1
   
    invoke CreateWindowEx, WS_EX_CLIENTEDGE, addr classedit, 0, WS_CHILD or WS_VISIBLE or WS_BORDER or ES_RIGHT,\
           60, 33, 105, 22, hWnd, 0, uchwyt, 0
       	 mov hEdit2, eax

    invoke CreateWindowEx, 0, addr classedit1, addr Edit3Text, WS_CHILD or WS_VISIBLE or ES_CENTER,\
 	   10, 11, 35, 22, hWnd, 0, uchwyt, 0 			;STATIC HEX
    	    	   
    invoke CreateWindowEx, 0, addr classedit1, 0, WS_CHILD or WS_VISIBLE or ES_CENTER,\
           10, 34, 35, 22, hWnd, 0, uchwyt, 0			;STATIC DEC
	mov hEdit4, eax
	       
    invoke CreateWindowEx, 0, addr classbutton, addr Button2Text, WS_CHILD or WS_VISIBLE or BS_DEFPUSHBUTTON,\
	   185, 10, 60, 22, hWnd, Button1ID, uchwyt, 0 
        
    invoke CreateWindowEx, 0, addr classbutton, addr Button1Text, WS_CHILD or WS_VISIBLE or BS_DEFPUSHBUTTON,\
	   185, 33, 60, 22, hWnd, Button2ID, uchwyt, 0 
    
    invoke SetWindowTextA, hEdit4, addr Edit4Text	;wprowadzenie tekstu do statica DEC
					;demonstracja dynamicznego tworzenia napisu w static'u

        push edx
	push ecx

     invoke LoadLibrary, addr LibName
	mov  hLib, eax
	cmp eax, 0h
	jz brak_dll	
     invoke GetProcAddress, hLib, addr szFunction1
	mov  Function1Offset, eax
     invoke GetProcAddress, hLib, addr szFunction3
	mov  Function3Offset, eax
     invoke GetProcAddress, hLib, addr szFunction4
	mov  Function4Offset, eax	
     	
	pop ecx
	pop edx	

nie_create:
    		cmp uMsg,WM_COMMAND
    		jnz dalej
        	mov eax,wParam
        	cmp ax,Button2ID
        	jnz Button1
        	shr eax,16
        	cmp ax,BN_CLICKED
        	jnz Button1
        	invoke PostQuitMessage,0

Button1:   

        	cmp ax,Button1ID
        	jnz dalej
        	shr eax,16
        	cmp ax,BN_CLICKED
        	jnz dalej

     invoke GetWindowTextA, hEdit1, addr Bufor, 9
	mov dword PTR [Bufor3], eax
	mov ecx, eax
	mov dword PTR [Bufor1], 00h
	mov dword PTR [Bufor1+4], 00h
				    
	push edi		
	push esi
	push ebp
        push ebx     
		
	call czy_hex
	mov  eax, ecx		
	mov  esi, offset Bufor
	mov  edi, offset Bufor1 	
	call Function1Offset    	;_odwrot 
	mov  esi, offset Bufor1
	mov  edi, offset Bufor2 	
	call Function3Offset    	;_strhex_na_dwordp
	mov  esi, offset Bufor3
	mov  eax, [edi]
	call Function4Offset    	;_hex_na_dec
		
      	pop ebx           		
	pop ebp 
	pop esi 	      
        pop edi

    invoke SetWindowTextA, hEdit2, addr Bufor3		
	invoke SetFocus, hEdit1
    ret

brak_dll:
	invoke MessageBox, 0, addr msgTekst2, addr msgTytul2, MB_OK
	jmp zamknij

dalej:
    invoke DefWindowProc, hWnd, uMsg, wParam, lParam
  ret

WndProc endp

;
;______________ koniec WndProc ______________________________________________________________
;

;
;======================= czy_hex PROC =======================================================

; Jeli do Edit zostanie wpisany znak z poza zakresu 0 - F wywietlony zostanie
; MessageBox i po naciniciu OK program zostanie zamknity

czy_hex	PROC

	push 	eax
	lea	esi,  Bufor
	
	mov	al, byte PTR [esi]    	
	cmp	al, 47h
	jae	messag
	inc	esi

	mov	al, byte PTR [esi]
	cmp	al, 47h
	jae	messag
	inc	esi

	mov	al, byte PTR [esi]
	cmp	al, 47h
	jae	messag
	inc	esi

	mov	al, byte PTR [esi]
	cmp	al, 47h
	jae	messag
	inc	esi

	mov	al, byte PTR [esi]	
	cmp	al, 47h
	jae	messag
	inc	esi

	mov	al, byte PTR [esi]	
	cmp	al, 47h
	jae	messag
	inc	esi

mov	al, byte PTR [esi]	
	cmp	al, 47h
	jae	messag
	inc	esi

mov	al, byte PTR [esi]	
	cmp	al, 47h
	jae	messag
	jb	dobr
		
messag:
	invoke MessageBox, 0, addr msgTekst, addr msgTytul, MB_OK 
	jmp zamknij
      ret
dobr:
	pop	eax
	ret

czy_hex	ENDP

;_________________ koniec czy_hex __________________________________________________________
;

end start
