; Silnia.asm. Oblicza silni dla liczb 1 do 12 (dec). Przyczyna ograniczenia
; jest oczywista - pojemno rejestru. Procedur mona rozbudowa 
; wykorzystujc aretmetyk duych liczb opisan na stronie Bogdana -
; bogdro - cz_14.htm o podtytule "... gdy liczby nie mieszcz si w rejestrach"

; Autor: Remek

.386
.model flat,stdcall
option casemap:none

include C:\masm32\include\windows.inc

include C:\masm32\include\user32.inc
include C:\masm32\include\kernel32.inc
includelib C:\masm32\lib\user32.lib
includelib C:\masm32\lib\kernel32.lib

.data

klasa       db "WinClass",0
tytul       db "Oblicza silni z liczby maksimum 12d", 0
classbutton db "button",0
Button1Text db "OK",0
Button2Text db "Exit",0
classedit   db "edit",0
classedit1  db "STATIC",0
Etxt1       db "Wpisz liczb 1 - 12", 0
Etxt2       db "Wynik:", 0
lpText	    db "Wpisz 1 - 12", 0	
lpCaption   db "   Info", 0
dziesietnie db 24 dup(?)
Bufor       db 20 dup(?)
Bufor1      dw 16 dup(?)
Bufor2      dw 16 dup(?)

.data?

uchwyt      dd ?
hEdit1      dd ?
hEdit2      dd ?

.const

Button1ID   equ 3
Button2ID   equ 4

.code

start:

    push 0
    call GetModuleHandleA
    mov uchwyt,eax
    
   	call WinMain
koniec:   
    	push 0
    	call ExitProcess

WinMain proc

    LOCAL wc:WNDCLASSEX
    LOCAL msg:MSG
    LOCAL hwnd:HWND
    mov wc.cbSize,SIZEOF WNDCLASSEX
    mov wc.style,CS_HREDRAW or CS_VREDRAW   
    mov wc.lpfnWndProc,offset WndProc
    mov wc.cbClsExtra,0
    mov wc.cbWndExtra,0
    push uchwyt
    pop wc.hInstance
    mov wc.hbrBackground,COLOR_WINDOW
    mov wc.lpszMenuName,0
    mov wc.lpszClassName,offset klasa
    invoke LoadIcon, 0, IDI_APPLICATION
    mov wc.hIcon,eax
    mov wc.hIconSm,eax
    invoke LoadCursor, 0, IDC_ARROW
    mov wc.hCursor,eax

    push eax
    lea eax,dword ptr [wc]
    push eax
    call RegisterClassEx
    pop eax

    invoke CreateWindowEx, WS_OVERLAPPEDWINDOW, offset klasa, offset tytul, WS_TILEDWINDOW,\
           500, 400, 290, 90, 0, 0, uchwyt, 0	
    mov hwnd, eax
    invoke ShowWindow, hwnd, SW_SHOWNORMAL
    invoke UpdateWindow, hwnd
 
messageloop:

    push 0
    push 0
    push 0
    lea ebx,dword ptr [msg]
    push ebx
    call GetMessage
    test eax,eax
    jz koniec_messageloop

    lea ecx,dword ptr [msg]
    push ecx
    call TranslateMessage

    lea edx,dword ptr [msg]
    push edx
    call DispatchMessage
    jmp messageloop

koniec_messageloop:

    mov eax,msg.wParam
    ret

WinMain endp


WndProc proc hWnd:HWND,uMsg:UINT,wParam:WPARAM,lParam:LPARAM
    
    cmp uMsg,WM_DESTROY
    jnz nie_destroy
    
    push 0
    call PostQuitMessage

nie_destroy:

    cmp uMsg,WM_CREATE
    jnz nie_create

    invoke CreateWindowEx,WS_EX_CLIENTEDGE,addr classedit,0,WS_CHILD or WS_VISIBLE or WS_BORDER or ES_RIGHT,\
           150, 10, 30, 22, hWnd,0, uchwyt, 0 	
    	mov hEdit1,eax
    invoke SetFocus, hEdit1
   
    invoke CreateWindowEx,WS_EX_CLIENTEDGE,addr classedit,0,WS_CHILD or WS_VISIBLE or WS_BORDER or ES_RIGHT,\
           105, 33, 105, 22, hWnd,0, uchwyt, 0
    	mov hEdit2,eax
   
    invoke CreateWindowEx,WS_EX_CLIENTEDGE,addr classedit1,addr Etxt1,WS_CHILD or WS_VISIBLE or WS_BORDER,\
           10, 10, 95, 22, hWnd,0, uchwyt, 0

    invoke CreateWindowEx,WS_EX_CLIENTEDGE,addr classedit1,addr Etxt2,WS_CHILD or WS_VISIBLE or WS_BORDER or ES_CENTER,\
           10, 33, 95, 22, hWnd,0, uchwyt, 0
    
    invoke CreateWindowEx,0,addr classbutton,addr Button1Text,WS_CHILD or WS_VISIBLE or BS_DEFPUSHBUTTON,\
           215,10,60,22,hWnd,Button1ID,uchwyt,0
    
    invoke CreateWindowEx,0,addr classbutton,addr Button2Text,WS_CHILD or WS_VISIBLE or BS_DEFPUSHBUTTON,\
           215,33,60,22,hWnd,Button2ID,uchwyt,0
    	
nie_create:

    	cmp uMsg,WM_COMMAND
    	jnz dalej
        mov eax,wParam
        cmp ax,Button2ID
        jnz Button1
        shr eax,16
        cmp ax,BN_CLICKED
        jnz Button1
        invoke PostQuitMessage,0

Button1:   

        cmp ax,Button1ID
        jnz dalej
        shr eax,16
        cmp ax,BN_CLICKED
        jnz dalej

        invoke GetWindowTextA, hEdit1, addr Bufor, 6
	      	
	push esi     
        push edi     
	push ebp
	push ebx
	
	xor  eax, eax           
	xor  ebx, ebx
	xor  ecx, ecx
	xor  esi, esi

;Bufor  - tu pobieramy znaki z edita
;Bufor1 - bufor poredni w procedurze
;Bufor2 - tu adujemy znaki do wywietlenia

	lea esi, Bufor			; adresy buforw do rejestrw
	lea edi, Bufor2			 	
	
;===== pobieramy znaki z bufora tekstowego i zamieniamy z ASCII na liczb w hex =========

	xor  edi, edi
	mov  edx, esi		;przenosimy adres z esi do edx
	mov al, 0Ah		;procedura ASCII/HEX - pocztek |
tata:				;				|
	mov bl, [edx]		;				|
	test bl, bl		;				|
	jz aaaa			;				|
	sub bl, 30h		;				|
        imul edi, eax		;wynik jest w edi		|
	add edi, ebx		;				|
	inc edx			;				|
	jmp tata		;procedura DEC/HEX - koniec >>>	|

aaaa:
	mov	dword PTR [Bufor1], edi
	cmp	edi, 0
	jz	exit

	cmp  dword ptr [Bufor1], 0000000Dh
 	jae  messag
	
 	mov	eax, dword PTR [Bufor1]		;<<<<<<<|
	mov 	ebx, 1				;	| procedura obliczajca silni
 	cmp 	eax, 1				;	| wynik jest ebx
 	jbe 	exit				;	|
	mov 	ebx, eax			;	|
loopa:						;	|
 	dec  	eax				;	|
 	or   	eax, eax			;	|
 	jz   	exit				;	|
	imul 	ebx, eax		        ;       |
 	jmp  	loopa				;<<<<<<<|
	
exit:
	call  hex_na_dec
		
	pop ebx
	pop ebp
	pop edi
        pop esi		    
	    
	invoke SetWindowTextA, hEdit2, addr dziesietnie 
     ret
        jmp dalej
messag:

	pop ebx
	pop ebp
	pop edi
        pop esi
 
	invoke MessageBox,0, addr lpText, addr lpCaption, MB_OK
     ret
	     
dalej:
    
    invoke DefWindowProc, hWnd, uMsg, wParam, lParam
 ret

WndProc endp


;=============== hex_na_dec PROC ===========================================================

; Procedura zamienia wpisan liczb hex na posta dziesitn 
;
;Xhemjl\Hex na dec.htm  Autor: Borzych. Adaptowana do Asm32.


hex_na_dec	PROC

	mov	 eax, ebx		  
	xor	 ebx, ebx

;---=== blok konwersji na system dziesitny ===---

        xor	ecx, ecx
        mov     cx, 10                  ;ptla bdzie powtarzana 10 razy
        mov     edi, 10                 ;dzielnik do edi
        mov     bx, 12                  ;bx wskazuje na ostatni element

zamiana:                                ;ptla zamiany kolejnych cyfr
        mov     edx, 0                  
        div     edi          ;dzielenie edx:eax, wynik w eax, reszta w edx
        add     dl, 30h                 ;zamiana na ASCII
        mov     dziesietnie[bx], dl     ;na koniec tablicy dodajemy kolejn cyfr
        dec     bx                      ;wskazuje na starsz cyfr

        cmp     bx, 9                   ;dzieli na trjki
        je      z_przerwa
        cmp     bx, 5                   ;dzieli na trjki
        je      z_przerwa
        cmp     bx, 1                   ;dzieli na trjki
        je      z_przerwa

        loop    zamiana
        jmp     usuwanie_zer            ;jak skoczy, idzie do usuwania zer

z_przerwa:
        dec     bx                      ;dodaje przerw
        loop    zamiana                 ;i wraca do ptli

usuwanie_zer:
        mov     cx, 12                  ;ptla usuwania zer
        mov     bx, 0                   ;wskazuje na pocztek tablicy

zera:                                   
        cmp     dziesietnie[bx], '0'    ;usunicie poczatkowych zer
        jne     przerwy                 ;jeeli pocztkowe rne od zera
        inc     bx                      ;idzie dalej
        loop    zera			;powtarzanie dla kolejnych cyfr

przerwy:
        mov     dziesietnie[9], ' '     ;robi z '0' przerwy
        mov     dziesietnie[5], ' '     ;robi z '0' przerwy
        mov     dziesietnie[1], ' '     ;robi z '0' przerwy
        
        ret                     

hex_na_dec	ENDP
  
;""""""""""""""""" koniec  hex_na_dec PROC """"""""""""""""""""""""""""""""""""""""""""""""""""

end start

