; Konwerter string na ASCII
; Program zamienia znaki wpisane z klawiatury do edit'a na ich reprezentacj
; w ASCII i wywietla w drugiej kontrolce

; Autor: Remek

.386
.model flat,stdcall
option casemap:none

include C:\masm32\include\windows.inc

include C:\masm32\include\user32.inc
include C:\masm32\include\kernel32.inc

includelib C:\masm32\lib\user32.lib
includelib C:\masm32\lib\kernel32.lib

 includelib C:\masm32\lib\remeka.lib

  _str_na_byte   PROTO

.data

klasa       	db "WinClass",0
tytul       	db "      String na ASCII.    Remek", 0
classbutton 	db "button",0
Button1Text 	db "Exit",0
Button2Text 	db "OK",0
classedit  	db "edit",0
classedit1  	db "static",0
Etx1		db "String", 0
Etx2		db "ASCII", 0
Bufor       	db 32 dup(?)
Bufor1      	db 32 dup(?)
Bufor4      	db 4 dup(?)

.data?

uchwyt      dd ?
hEdit1      dd ?
hEdit2      dd ?

.const

Button1ID   equ 3
Button2ID   equ 4
ID_ICON_CAPTION  equ 101

.code

start:

    push 0
    call GetModuleHandleA
    mov uchwyt,eax
    
    call WinMain
    
    push 0
    call ExitProcess

WinMain proc

   
    LOCAL decstr2:DWORD
    LOCAL wc:WNDCLASSEX
    LOCAL msg:MSG
    LOCAL hwnd:HWND
    mov wc.cbSize,SIZEOF WNDCLASSEX
    mov wc.style,CS_HREDRAW or CS_VREDRAW   
    mov wc.lpfnWndProc,offset WndProc
    mov wc.cbClsExtra,0
    mov wc.cbWndExtra,0
    push uchwyt
    pop wc.hInstance
    mov wc.hbrBackground,COLOR_WINDOW
    mov wc.lpszMenuName,0
    mov wc.lpszClassName,offset klasa

    ;invoke LoadIcon, 0, IDI_APPLICATION	  ;tak jest ikona mae okienko
    ;invoke LoadIcon, uchwyt, IDI_APPLICATION	  ;tak jest ikona Windows
    ;invoke LoadIcon, 0, ID_ICON_CAPTION          ;tak jest wykrzyknik w trjkcie
    invoke LoadIconA,uchwyt,ID_ICON_CAPTION	  ;tak jest ikona Bankruta (musi by zdefiniowana
						  ;w staej i w pliku *.res

    mov wc.hIcon,eax
    mov wc.hIconSm,eax
    
    invoke LoadCursor, 0, IDC_ARROW

    mov wc.hCursor,eax

    push eax
    lea eax,dword ptr [wc]
    push eax
    call RegisterClassEx
    pop eax
    
    invoke CreateWindowEx, WS_OVERLAPPEDWINDOW, offset klasa, offset tytul, WS_TILEDWINDOW,\
           450,300, 340, 90, 0, 0, uchwyt, 0	
    mov hwnd,eax
    invoke ShowWindow, hwnd, SW_SHOWNORMAL
    invoke UpdateWindow, hwnd

  
messageloop:

    push 0
    push 0
    push 0
    lea ebx,dword ptr [msg]
    push ebx
    call GetMessage
    test eax,eax
    jz koniec_messageloop

    lea ecx,dword ptr [msg]
    push ecx
    call TranslateMessage

    lea edx,dword ptr [msg]
    push edx
    call DispatchMessage
    jmp messageloop

koniec_messageloop:

    mov eax,msg.wParam
    ret

WinMain endp

WndProc proc hWnd:HWND,uMsg:UINT,wParam:WPARAM,lParam:LPARAM
   
    cmp uMsg,WM_DESTROY
    jnz nie_destroy
    
    push 0
    call PostQuitMessage
   
nie_destroy:

    cmp uMsg,WM_CREATE
    jnz nie_create

   invoke CreateWindowEx,WS_EX_CLIENTEDGE,ADDR classedit,0, WS_CHILD or WS_VISIBLE or WS_BORDER or ES_RIGHT,\
            90,10,130,22, hWnd, 0, uchwyt, 0 	
    	mov hEdit1,eax
      invoke SetFocus, hEdit1
   
    invoke CreateWindowEx, WS_EX_CLIENTEDGE, addr classedit, 0, WS_CHILD or WS_VISIBLE or WS_BORDER or ES_RIGHT,\
           60, 35, 200, 22, hWnd, 0, uchwyt, 0
    mov hEdit2, eax

    invoke CreateWindowEx, 0, addr classedit, addr Etx1, WS_CHILD or WS_VISIBLE or WS_BORDER or WS_DISABLED or ES_CENTER,\
           5, 10, 50, 22, hWnd, 0, uchwyt, 0
   
    invoke CreateWindowEx, 0, addr classedit, addr Etx2, WS_CHILD or WS_VISIBLE or WS_BORDER or WS_DISABLED or ES_CENTER,\
           5, 35, 50, 22, hWnd, 0, uchwyt, 0
         
    invoke CreateWindowEx, 0, addr classbutton, addr Button2Text, WS_CHILD or WS_VISIBLE or BS_DEFPUSHBUTTON,\
	265, 10, 60, 22, hWnd, Button1ID, uchwyt, 0
    
    invoke CreateWindowEx, 0, addr classbutton, addr Button1Text, WS_CHILD or WS_VISIBLE or BS_DEFPUSHBUTTON,\
	265, 35, 60, 22, hWnd, Button2ID, uchwyt, 0
    
nie_create:

    	cmp uMsg,WM_COMMAND
    	jnz dalej
        mov eax,wParam
        cmp ax,Button2ID
        jnz Button1
        shr eax,16
        cmp ax,BN_CLICKED
        jnz Button1
        invoke PostQuitMessage,0

Button1:   

        cmp ax,Button1ID
        jnz dalej
        shr eax,16
        cmp ax,BN_CLICKED
        jnz dalej
       
        invoke GetWindowTextA,hEdit1,addr Bufor,21
	mov  dword ptr [Bufor4], eax
	
	mov dword PTR [Bufor1], 00h
	mov dword PTR [Bufor1+4], 00h
	mov dword PTR [Bufor1+8], 00h
	mov dword PTR [Bufor1+12], 00h
	mov dword PTR [Bufor1+16], 00h
	mov dword PTR [Bufor1+20], 00h
      	
	push esi     			
	push edi
	push ebp
	push ebx     

		
	lea  esi, Bufor     	
	lea  edi, Bufor1
	call _str_na_byte
	
        pop ebx
	pop ebp	    
        pop edi           		
	pop esi  	      		
        
        invoke SetWindowTextA, hEdit2, addr Bufor1
	invoke SetFocus, hEdit1
     ret
        
dalej:
     invoke DefWindowProc, hWnd, uMsg, wParam, lParam 
    ret

WndProc endp


end start

