; Program ilustrujcy wykorzystanie funkcji wsprintf.
; Procedura zmienia liczb hex na dec zgodnie z formatem filtru
; podanym w zmiennej Format

; Autor: Remek

.386
.model flat,stdcall
option casemap:none

include C:\masm32\include\windows.inc
include C:\masm32\include\user32.inc
include C:\masm32\include\kernel32.inc
includelib C:\masm32\lib\user32.lib
includelib C:\masm32\lib\kernel32.lib

 INCLUDELIB C:\masm32\lib\remeka.lib

  _strhex_na_dwordp PROTO

.data

klasa       	db "WinClass",0
tytul       	db "      Program testowy",0
classbutton 	db "button",0
Button1Text 	db "Exit",0
Button2Text 	db "OK",0
Ed3Text		db "HEX", 0
Ed4Text		db "DEC", 0
classedit   	db "edit",0
classedit1	db "STATIC", 0
msgTytul	db "Info", 0
msgTekst	db "Wpisz 0-9", 0
Bufor       	db 20 dup(?)
Bufor1      	db 16 dup(?)
Bufor2      	db 16 dup(?)
Bufor3      	db 32 dup(?)
Format 		db "%ld", 0

.data?

uchwyt      	dd ?
hEdit1      	dd ?
hEdit2      	dd ?

.const

Button1ID   	equ 3
Button2ID   	equ 4

.code

start:

    	push 0
    	call GetModuleHandleA
    	mov uchwyt,eax
    
    	call WinMain
zamknij:    
    	push 0
    	call ExitProcess

WinMain proc

    LOCAL wc:WNDCLASSEX
    LOCAL msg:MSG
    LOCAL hwnd:HWND
    mov wc.cbSize,SIZEOF WNDCLASSEX
    mov wc.style,CS_HREDRAW or CS_VREDRAW   
    mov wc.lpfnWndProc,offset WndProc
    mov wc.cbClsExtra,0
    mov wc.cbWndExtra,0
    push uchwyt
    pop wc.hInstance
    mov wc.hbrBackground,COLOR_WINDOW
    mov wc.lpszMenuName,0
    mov wc.lpszClassName,offset klasa

    invoke LoadIcon, 0, IDI_APPLICATION
	
    mov wc.hIcon,eax
    mov wc.hIconSm,eax
    
    invoke LoadCursor, 0, IDC_ARROW

    mov wc.hCursor,eax

    push eax
    lea eax,dword ptr [wc]
    push eax
    call RegisterClassEx
    pop eax
    
    invoke CreateWindowEx, WS_OVERLAPPEDWINDOW, offset klasa, offset tytul, WS_TILEDWINDOW,\
	   435, 400, 335, 90, 0, 0, uchwyt, 0	
    	mov hwnd,eax
    invoke ShowWindow, hwnd, SW_SHOWNORMAL
    invoke UpdateWindow, hwnd

messageloop:

    	push 0
    	push 0
    	push 0
    	lea ebx, dword ptr [msg]
    	push ebx
    	call GetMessage
    	test eax, eax
    	jz koniec_messageloop

    	lea ecx, dword ptr [msg]
    	push ecx
    	call TranslateMessage

    	lea edx, dword ptr [msg]
    	push edx
    	call DispatchMessage
    	jmp messageloop

koniec_messageloop:

    	mov eax,msg.wParam
      ret

WinMain endp

WndProc proc hWnd:HWND,uMsg:UINT,wParam:WPARAM,lParam:LPARAM
    
    cmp uMsg,WM_DESTROY
    jnz nie_destroy
    
    push 0
    call PostQuitMessage

nie_destroy:

    cmp uMsg,WM_CREATE
    jnz nie_create

    invoke CreateWindowEx, WS_EX_CLIENTEDGE, ADDR classedit, 0, WS_CHILD or WS_VISIBLE or WS_BORDER or ES_RIGHT or ES_UPPERCASE,\
	   80, 10, 165, 22, hWnd, 0, uchwyt, 0 	
    	mov hEdit1, eax
     invoke SetFocus, hEdit1
   
    invoke CreateWindowEx, WS_EX_CLIENTEDGE, offset classedit, 0, WS_CHILD or WS_VISIBLE or WS_BORDER or ES_RIGHT,\
           80, 33, 165, 22, hWnd, 0, uchwyt, 0
    	mov hEdit2, eax
           
    invoke CreateWindowEx, WS_EX_CLIENTEDGE , addr classbutton, addr Button1Text, WS_CHILD or WS_VISIBLE or BS_DEFPUSHBUTTON,\
	   255, 10, 60, 22, hWnd, Button1ID, uchwyt, 0
  
    invoke CreateWindowEx, WS_EX_CLIENTEDGE , addr classbutton, addr Button2Text, WS_CHILD or WS_VISIBLE or BS_DEFPUSHBUTTON,\
	   255, 33, 60, 22, hWnd, Button2ID, uchwyt, 0
  
    invoke CreateWindowEx, WS_EX_CLIENTEDGE , addr classedit1, addr Ed3Text, WS_CHILD or WS_VISIBLE,\
	   10, 10, 60, 22, hWnd, 0, uchwyt, 0
  
    invoke CreateWindowEx, WS_EX_CLIENTEDGE , addr classedit1, addr Ed4Text, WS_CHILD or WS_VISIBLE,\
	   10, 33, 60, 22, hWnd, 0, uchwyt, 0
  
nie_create:

    	cmp uMsg,WM_COMMAND
    	jnz dalej
        mov eax,wParam
        cmp ax,Button2ID
        jnz Button1
        shr eax,16
        cmp ax,BN_CLICKED
        jnz Button1
        invoke PostQuitMessage,0

Button1:   

        cmp ax,Button1ID
        jnz dalej
        shr eax,16
        cmp ax,BN_CLICKED
        jnz dalej

       invoke GetWindowTextA, hEdit1, addr Bufor, 21
	 
	mov ecx, eax 
      	
	push edi     		
	push esi
	push ebx
	push ebp  
           
	lea esi, Bufor    
	lea edi, Bufor1
	call _strhex_na_dwordp	 
	mov eax, [edi] 
	invoke wsprintf, addr Bufor2, addr Format, eax

	pop ebp
	pop ebx
	pop esi
	pop edi 	      	        
        
        invoke SetWindowTextA, hEdit2, addr Bufor2
      ret	

dalej:

     invoke DefWindowProc, hWnd, uMsg, wParam, lParam 

  ret

WndProc endp
 
end start

